#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll N = 100005;

ll c[N], v[N];

ll dp[N];

ll match(ll l, ll r, ll nol, ll nor, kek)
{
    if (r <= l)
        return 0;
    ll ans = 1e9;
    for (ll i = 1; i <= kek; i++)
    {
        ll t = ((l >> i) << i);
        if (t < nol)
            continue;
        ll j = 0;
        while (j + 1 <= i - 1)
        {
            if ((t | (1 << (j + 1))) > nor)
                break;
            j++;
        }
        if (t > l)
            ans = min(ans, 1 + match(t, r, nol, nor, i));
        t += (1 << i);
        if (t <= nor && t > l)
            ans = min(ans, 1 + match(t, r, nol, nor, i));
    }
    ans = min(ans, match(l + 1, r, nol, nor, 0) + 1);
    return ans;
}
vector<int> colors;
int used[N];

ll f(ll l, ll r, int col)
{
  //  cout << l << " " << r << " " << colors[col] << endl;
    if (r < l)
        return 0;
    ll ans = 1e9;
    vector<ll> cur;
    cur.clear();
    for (ll j = l; j <= r; j++)
    {
        if (c[j] == colors[col])
            cur.push_back(j);
    }
    if (!cur.size())
        return f(l, r, col + 1);
    for (ll j = 0; j < cur.size(); j++)
    {
        dp[j] = match(v[cur[0]], v[cur[j] + 1], v[l], v[r + 1], 29);
        for (ll k = 0; k < j; k++)
            dp[j] = min(dp[j], dp[k] + match(v[cur[k + 1]], v[cur[j] + 1], v[l], v[r + 1], 29));
    }
    ll curans = dp[cur.size() - 1];
    curans += f(l, cur[0] - 1, col + 1);
    curans += f(cur.back() + 1, r, col + 1);
    for (ll i = 1; i < cur.size(); i++)
        curans += f(cur[i - 1] + 1, cur[i] - 1, col + 1);
    return curans;
}

ll ans = 1e18;

int m, k, n;

int cnt[N];

void gen(int k)
{
    if (k == m)
    {
        ans = min(ans, f(0, n - 1, 0));
        return;
    }
    for (int i = 1; i <= m; i++)
        if (!used[i])
        {
            used[i] = 1;
            colors.push_back(i);
            gen(k + 1);
            colors.pop_back();
            used[i] = 0;
        }
}

int main()
{
    cin >> k >> n >> m;
    for (ll i = 0; i < n; i++)
    {
        cin >> v[i + 1] >> c[i];
    }
    for (ll i = 1; i <= n; i++)
        v[i] += v[i - 1];
    gen(0);
    cout << ans;
    return 0;
}
/*
3 3 2
1 1
2 2
5 1

3 8 8
1 1
1 2
1 3
1 4
1 5
1 6
1 7
1 8


3 8 2
1 1
1 2
1 1
1 2
1 1
1 2
1 1
1 2

*/
